<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TransformationTestSupport xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/common/testutils/TransformationTestSupport.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2017 CEA LIST</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     Ansgar Radermacher (CEA LIST) - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.common.testutils;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> <strong class="jxr_keyword">static</strong> org.hamcrest.MatcherAssert.assertThat;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IFolder;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IProject;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.NullProgressMonitor;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.ElementUtils;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.TestInfo;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ProjectManagement;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.InstantiateDepPlan;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.junit.utils.rules.AbstractHouseKeeperRule;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.junit.utils.rules.PapyrusEditorFixture;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.osgi.framework.Bundle;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.osgi.framework.FrameworkUtil;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/testutils/TransformationTestSupport.html">TransformationTestSupport</a> {
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  	<strong class="jxr_keyword">static</strong> {
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  		<em class="jxr_comment">// This system property avoids opening dialogs during Papyrus operations. It must</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  		<em class="jxr_comment">// be set before trying to load any of the Papyrus classes.</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  		System.setProperty(TestInfo.PAPYRUS_RUN_HEADLESS, Boolean.TRUE.toString());
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  	}
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment">	 * The house keeper</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	<strong class="jxr_keyword">protected</strong> AbstractHouseKeeperRule houseKeeper;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment">	 * The modelSetFixture</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<strong class="jxr_keyword">protected</strong> PapyrusEditorFixture modelSetFixture;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 * The test class (used to get access to its bundle)</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	Class&lt;?&gt; testClass;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/testutils/TransformationTestSupport.html">TransformationTestSupport</a>(Class&lt;?&gt; testClass, AbstractHouseKeeperRule houseKeeper, PapyrusEditorFixture modelSetFixture) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		<strong class="jxr_keyword">this</strong>.houseKeeper = houseKeeper;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">this</strong>.modelSetFixture = modelSetFixture;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  		<strong class="jxr_keyword">this</strong>.testClass = testClass;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	}
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 * Run a transformation with a given deployment plan</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 * @param depPlanName the qualified name of a deployment plan within the provided example</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> runTransformation(String depPlanName) {
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		NamedElement depPlan = ElementUtils.getQualifiedElement(modelSetFixture.getModel(), depPlanName);
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		<strong class="jxr_keyword">if</strong> (depPlan instanceof Package) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			IProject project = ProjectManagement.getCurrentProject();
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			Package selectedCDP = (Package) depPlan;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> genOptions = 0;
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			<strong class="jxr_keyword">new</strong> InstantiateDepPlan().instantiate(selectedCDP, <strong class="jxr_keyword">new</strong> NullProgressMonitor(), project, genOptions);
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  		}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  	}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  <em class="jxr_javadoccomment">	 * Validate the results</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 * @param genProject the project into which generation has been done;</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 * @param folderInTestBundle The folder within the source bundle containing the expected results</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 * @param folderInModelProject The folder name containing the generated code (a folder of the same name is created within the model project to facilitate the comparison)</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> validateResults(IProject genProject, String folderInTestBundle, String srcGen) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		IProject modelProject = modelSetFixture.getProject().getProject();
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		RecursiveCopy copier = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/testutils/RecursiveCopy.html">RecursiveCopy</a>(houseKeeper);
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  		Bundle srcBundle = FrameworkUtil.getBundle(testClass);
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		<em class="jxr_comment">// copy expected results folder to model project</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		copier.copy(srcBundle, folderInTestBundle, modelProject, srcGen);
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  		IFolder expectedSrcGen = modelProject.getFolder(srcGen);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		assertThat(<span class="jxr_string">"expected source folder must exist"</span>, expectedSrcGen.exists());
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		IFolder generatedSrcGen = genProject.getFolder(srcGen);
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		assertThat(<span class="jxr_string">"generated source folder must exist"</span>, generatedSrcGen.exists());
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		FileComparison.assertGeneratedMatchesExpected(generatedSrcGen, expectedSrcGen);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  	}
<a class="jxr_linenumber" name="L100" href="#L100">100</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
